Index: trunk/login.php
===================================================================
--- trunk/login.php	(revision 5764)
+++ trunk/login.php	(revision 5804)
@@ -131,7 +131,15 @@
             $_SESSION['wallet']['user']['uidNumber']      =  $GLOBALS['phpgw_info']['user']['account_id'];
             $_SESSION['wallet']['user']['password']       =  $GLOBALS['phpgw_info']['user']['passwd'];
-            $_SESSION['wallet']['user']['cn']             =  $GLOBALS['phpgw_info']['user']['cn'];
+            $_SESSION['wallet']['user']['cn']             =  $GLOBALS['phpgw_info']['user']['firstname'].' '.$GLOBALS['phpgw_info']['user']['lastname'];
             $_SESSION['wallet']['user']['mail']           =  $GLOBALS['phpgw_info']['user']['email'];
             
+            
+            ob_start();
+            print_r($GLOBALS['phpgw_info']['user']);
+
+            $output = ob_get_clean();
+            file_put_contents( "/tmp/acoutinho.log",  $output , FILE_APPEND);
+	
+
             
         
Index: trunk/expressoAdmin1_2/inc/class.uishared_accounts.inc.php
===================================================================
--- trunk/expressoAdmin1_2/inc/class.uishared_accounts.inc.php	(revision 5133)
+++ trunk/expressoAdmin1_2/inc/class.uishared_accounts.inc.php	(revision 5804)
@@ -51,4 +51,9 @@
 			$contexts = $acl['contexts'];
                         
+                        // Loading Config Module
+                        $conf = CreateObject('phpgwapi.config','phpgwapi');
+                        $conf->read_repository();
+                        $config = $conf->config_data;  
+                        
 			foreach ($acl['contexts_display'] as $index=>$tmp_context) {
 				$context_display .= '<br>'.$tmp_context;
@@ -100,5 +105,7 @@
                             'changequote_disabled' => $this->functions->check_acl($account_lid,'edit_shared_accounts_quote') ? '' : 'readonly',
                             'disabled_empty_inbox' => $this->functions->check_acl($account_lid,'empty_shared_accounts_inbox') ? '' : 'disabled',
-                            'display_quota_used' => 'none'
+                            'display_quota_used' => 'none',
+                            'aclExpressoCalendar' => (isset($config['defaultCalendar']) && ($config['defaultCalendar'] == 'expressoCalendar')) ? '' : 'none',
+                            'aclCalendar' => (isset($config['defaultCalendar']) && ($config['defaultCalendar'] == 'calendar')) ? '' : 'none'
                         );
                         $p->set_var($var);
@@ -107,7 +114,7 @@
 			
 			$var = Array(
-				'th_bg'						=> $GLOBALS['phpgw_info']['theme']['th_bg'],
-				'back_url'					=> $GLOBALS['phpgw']->link('/expressoAdmin1_2/index.php'),
-				'context_display'			=> $context_display,
+				'th_bg'	=> $GLOBALS['phpgw_info']['theme']['th_bg'],
+				'back_url' => $GLOBALS['phpgw']->link('/expressoAdmin1_2/index.php'),
+				'context_display' => $context_display,
 				'shared_accounts_modal' => $shared_accounts_modal_tpl,                                
 				'onclick_create_shared_account' => "modal(\"$modal_id\",\"create\")"
Index: trunk/expressoAdmin1_2/js/jscode/shared_accounts.js
===================================================================
--- trunk/expressoAdmin1_2/js/jscode/shared_accounts.js	(revision 5589)
+++ trunk/expressoAdmin1_2/js/jscode/shared_accounts.js	(revision 5804)
@@ -168,4 +168,5 @@
 		Element('em_input_saveAcl').checked = false;
 		Element('em_input_folderAcl').checked = false;
+                
                 Element('em_input_readCalendar').checked = false;
                 Element('em_input_writeCalendar').checked = false;
@@ -173,4 +174,11 @@
                 Element('em_input_deleteCalendar').checked = false;
                 Element('em_input_restrictCalendar').checked = false;
+                
+                Element('em_input_readExpressoCalendar').checked = false;
+                Element('em_input_writeExpressoCalendar').checked = false;
+                Element('em_input_freebusyExpressoCalendar').checked = false;
+                Element('em_input_deleteExpressoCalendar').checked = false;
+                
+                
         Element('em_input_sendAcl').disabled = true;
         select_owners = Element('ea_select_owners');
@@ -182,7 +190,9 @@
 {
 	select_owners = Element('ea_select_owners');
+        
+        var user = '';
 	for(var i = 0;i < select_owners.options.length; i++)
 		if(select_owners.options[i].selected){
-                        var user = select_owners.options[i].value;
+                        user = select_owners.options[i].value;
                         delete sharemailbox.ownersAcl[user];
                        sharemailbox.ownersCalendarAcl[user] = '';
@@ -193,7 +203,27 @@
        if(select_owners.options.length > 0 ){
             select_owners.options[0].selected = true;
-            var user = select_owners.options[0].value;
+            user = select_owners.options[0].value;
             sharemailbox.getaclfromuser(user);
        }
+       
+       if(sharemailbox.ownersExpressoCalendarAcl){
+
+            delete sharemailbox.ownersExpressoCalendarAcl[user];
+
+            var sharedUser = DataLayer.get('user', {filter: ['=','mail',$('#mail').val()]});
+            var signature = DataLayer.get('calendarSignature', {filter: ['=','user', sharedUser[0].id]});
+
+            var usuario = DataLayer.get('user', {filter: ['AND', ['=','uid',user], ['*','mail',user] ]});
+            var calendarPermission = DataLayer.get('calendarToPermission', {filter: ['AND', ['=','calendar',signature[0].calendar], ['=','user',usuario[0].id] ] });
+
+            var signatureUser = DataLayer.get('calendarSignature', {filter: ['AND', ['=','calendar', signature[0].calendar], ['=','user', usuario[0].id ] ]});
+
+            DataLayer.remove('calendarSignature', signatureUser[0].id);
+            DataLayer.remove('calendarToPermission', calendarPermission[0].id);
+
+        }
+       
+       
+       
 }
 
@@ -261,7 +291,9 @@
             Element('desc').value = data.description;
             //Necessario, pois o IE6 tem um bug que não exibe as novas opções se o innerHTML estava vazio
-            Element('ea_select_owners').innerHTML = '&nbsp;' + data.owners_options;
-            Element('ea_select_owners').outerHTML = Element('ea_select_owners').outerHTML;
-
+            
+            if(data.owners_options){
+                Element('ea_select_owners').innerHTML = '&nbsp;' + data.owners_options;
+                Element('ea_select_owners').outerHTML = Element('ea_select_owners').outerHTML;
+            }
             Element('display_empty_inbox').style.display = data.display_empty_inbox;
             if( data.allow_edit_shared_account_acl == "0"){
@@ -283,9 +315,35 @@
                         sharemailbox.ownersCalendarAcl = new Array();
             if( data.owners && data.owners != "undefined" && data.owners_acl != "undefined" ){ 
-				for (i=0; i<data.owners.length; i++){
-						sharemailbox.ownersAcl[ data.owners[i] ] = data.owners_acl[i];	
-                                                sharemailbox.ownersCalendarAcl[ data.owners[i] ] = data.owners_calendar_acl[i];
-				}
+                for (i=0; i<data.owners.length; i++){
+                                sharemailbox.ownersAcl[ data.owners[i] ] = data.owners_acl[i];	
+                                sharemailbox.ownersCalendarAcl[ data.owners[i] ] = data.owners_calendar_acl[i];
+                }
             }
+
+            //new API compatibility
+            var signature = DataLayer.get('calendarSignature', {filter: ['=','user', data.uidnumber]});
+            if(!!signature){
+                sharemailbox.currentPemissions[data.uidnumber] = true;
+                var calendarPermission = DataLayer.get('calendarToPermission:detail', {filter: ['=','calendar',signature[0].calendar], criteria:{deepness: 2}});
+                if(calendarPermission){
+                    var owners_options = '';
+                    for (i=0; i < calendarPermission.length; i++){
+                        sharemailbox.ownersExpressoCalendarAcl[ calendarPermission[i].user.uid ] = calendarPermission[i].aclValues;
+                        owners_options += '<option value='+calendarPermission[i].user.uid+'>'+calendarPermission[i].user.name+'</option>'
+                        sharemailbox.currentPemissions[calendarPermission[i].user.uid] = calendarPermission[i].id;
+                    }
+
+
+                    delete sharemailbox.currentPemissions[undefined];
+                    delete sharemailbox.currentPemissions[undefined];
+
+                    Element('ea_select_owners').innerHTML = '&nbsp;' + owners_options;
+                    Element('ea_select_owners').outerHTML = Element('ea_select_owners').outerHTML;
+                    
+                }
+        
+            }
+            
+            
 		}
 		else
@@ -304,15 +362,88 @@
 	else   form = document.forms["shared_accounts_form"];
         
-         hidden_owners_calendar_acl = Element('owners_calendar_acls');
+        hidden_owners_calendar_acl = Element('owners_calendar_acls');
 	hidden_owners_acl = Element('owners_acls');
 	select_owners = Element('ea_select_owners');
 	for(var i = 0;i < select_owners.options.length; i++){		
-		var user = select_owners.options[i].value;                
-		select_owners.options[i].value = user;
-		}
+            var user = select_owners.options[i].value;                
+            select_owners.options[i].value = user;
+        }
         hidden_owners_acl.value =  admin_connector.serialize(sharemailbox.ownersAcl);
+        
+        if(sharemailbox.ownersExpressoCalendarAcl){
+            
+            var calback = function(){
+                var sharedUser = DataLayer.get('user', {filter: ['=','mail',$('#mail').val()]});
+
+                if(!!sharedUser && $.isArray(sharedUser))
+                    sharedUser = sharedUser[0];
+
+                if(!!!sharemailbox.currentPemissions[sharedUser.id])
+                    DataLayer.put('calendarSignature', {
+                        user: sharedUser.id,
+                        calendar:  {
+                            timezone: 'America/Sao_Paulo',
+                            name: $('#cn').val(),
+                            location : $('#cn').val(),
+                            description : $('#cn').val()
+                            },
+                        isOwner:  '1',
+                        fontColor:  '000000',
+                        backgroundColor: 'f1efac',
+                        borderColor: 'eddb21'
+                    });
+
+                var returns = function(data){
+                    
+                    
+                    var calendar = '';
+                    
+                    if(data){
+                        for(var i in data)
+                            if(i.indexOf('calendar:') >= 0)
+                                calendar = data[i].id;
+                    }else{
+                        calendar = DataLayer.get('calendarSignature', {filter: ['=','user', sharedUser.id]});
+                        calendar = calendar[0].calendar;
+                    }
+                    
+                $.each(sharemailbox.ownersExpressoCalendarAcl, function(user, acl) {
+
+                        var usuario = DataLayer.get('user', {filter: ['AND', ['=','uid',user], ['*','mail',user] ]});
+
+                        if($.isArray(usuario))
+                            usuario = usuario[0];
+
+                        
+                        DataLayer.put('calendarToPermission', DataLayer.merge({
+                            user:  usuario.id,
+                            type: '0',
+                            acl: acl,
+                            calendar: calendar
+                        }, !!sharemailbox.currentPemissions[usuario.uid] ? {id: sharemailbox.currentPemissions[usuario.uid]} : {}));
+                        
+                        if(!!!sharemailbox.currentPemissions[usuario.uid])
+                            DataLayer.put('calendarSignature', {
+                                user: usuario.id,
+                                calendar:  calendar,
+                                isOwner:  '0',
+                                fontColor:  '000000',
+                                backgroundColor: 'f1efac',
+                                borderColor: 'eddb21'
+                            });
+
+                    })
+                    DataLayer.commit();  
+                };
+                if(!!sharemailbox.currentPemissions[sharedUser.id])
+                    returns(false);
+                else
+                    DataLayer.commit(false, false, returns);
+            }
+        }
         hidden_owners_calendar_acl.value =  admin_connector.serialize(sharemailbox.ownersCalendarAcl);
 	cExecuteForm ("$this.shared_accounts.save", form, handler_save_shared_accounts);
         get_shared_accounts(Element('ea_shared_account_search').value);
+        calback();
 }
 
@@ -364,4 +495,6 @@
 		this.ownersAcl = new Array();
                 this.ownersCalendarAcl = new Array();
+                this.ownersExpressoCalendarAcl = {};
+                this.currentPemissions = {};
 	}
 
@@ -409,7 +542,38 @@
                 Element('em_input_restrictCalendar').checked = false;
 
+                Element('em_input_readExpressoCalendar').checked = false;
+                Element('em_input_writeExpressoCalendar').checked = false;
+                Element('em_input_freebusyExpressoCalendar').checked = false;
+                Element('em_input_deleteExpressoCalendar').checked = false;
+
                 Element('em_input_editCalendar').disabled = true;
                 Element('em_input_deleteCalendar').disabled = true;
                 Element('em_input_restrictCalendar').disabled = true;
+                
+                
+                if(this.ownersExpressoCalendarAcl[user])
+                {
+                    if (this.ownersExpressoCalendarAcl[user].indexOf('r') >= 0)
+                    {
+                            Element('em_input_readExpressoCalendar').checked = true;
+                            Element('em_input_writeExpressoCalendar').checked = false;
+                            Element('em_input_freebusyExpressoCalendar').checked = false;
+                            Element('em_input_deleteExpressoCalendar').checked = false;
+                            
+                    }
+                    if (this.ownersExpressoCalendarAcl[user].indexOf('w') >= 0)
+                    {
+                            Element('em_input_writeExpressoCalendar').checked = true;
+                    }
+                    if (this.ownersExpressoCalendarAcl[user].indexOf('d') >= 0)
+                    {
+                            Element('em_input_deleteExpressoCalendar').checked = true;
+                    }
+                    if (this.ownersExpressoCalendarAcl[user].indexOf('b') >= 0)
+                    {
+                            Element('em_input_freebusyExpressoCalendar').checked = true;
+                    }
+                }
+                
 		
                 if(this.ownersCalendarAcl[user])
@@ -418,20 +582,28 @@
                     {
                             Element('em_input_readCalendar').checked = true;
-
                             Element('em_input_editCalendar').disabled = false;
                             Element('em_input_deleteCalendar').disabled = false;
                             Element('em_input_restrictCalendar').disabled = false;
+                            
+                            Element('em_input_readExpressoCalendar').checked = true;
+                            Element('em_input_writeExpressoCalendar').checked = false;
+                            Element('em_input_freebusyExpressoCalendar').checked = false;
+                            Element('em_input_deleteExpressoCalendar').checked = false;
+                            
                     }
                     if (this.ownersCalendarAcl[user].indexOf('2-',0) >= 0)
                     {
                             Element('em_input_writeCalendar').checked = true;
+                            Element('em_input_writeExpressoCalendar').checked = true;
                     }
                     if (this.ownersCalendarAcl[user].indexOf('4-',0) >= 0)
                     {
                             Element('em_input_editCalendar').checked = true;
+                            Element('em_input_writeExpressoCalendar').checked = true;
                     }
                     if (this.ownersCalendarAcl[user].indexOf('8-',0) >= 0)
                     {
                             Element('em_input_deleteCalendar').checked = true;
+                            Element('em_input_deleteExpressoCalendar').checked = true;
                     }
                     if (this.ownersCalendarAcl[user].indexOf('16-',0) >= 0)
@@ -535,4 +707,6 @@
 		var acl		= '';
 		var select 	= Element('ea_select_owners');
+                
+                sharemailbox.ownersExpressoCalendarAcl = false;
 
 		if(select.selectedIndex == "-1"){
@@ -556,9 +730,9 @@
                         Element('em_input_deleteCalendar').disabled = false;
                         Element('em_input_restrictCalendar').disabled = false;
-
+                        
                         if (Element('em_input_editCalendar').checked)
                                 acl += '4-';
 
-                        if (Element('em_input_deleteCalendar').checked)
+                        if (Element('em_input_deleteCalendar').checked )
                                 acl += '8-';
 
@@ -574,11 +748,77 @@
                         Element('em_input_deleteCalendar').checked = false;
                         Element('em_input_restrictCalendar').checked = false;
-                    }
-
-                    if (Element('em_input_writeCalendar').checked)
+                        
+                    }
+
+                    if (Element('em_input_writeCalendar').checked || Element('em_input_writeExpressoCalendar').checked)
                             acl += '2-';
 
 
                     this.ownersCalendarAcl[user] = acl;
+                }
+	}
+        
+        cShareMailbox.prototype.setExpressoCalendaraclfromuser = function()
+	{
+		var acl		= '';
+		var select 	= Element('ea_select_owners');
+                
+                sharemailbox.ownersCalendarAcl = false;
+
+		if(select.selectedIndex == "-1"){
+			alert("Selecione antes um usuario!");
+			return false;
+		}
+                
+                for(var k = 0; k < select.options.length; k ++ )
+                {
+                    if(select.options[k].selected !== true ) continue;
+                    
+                    acl = '';
+                    var user = select.options[k].value;
+                    
+                    if(Element('em_input_freebusyExpressoCalendar').checked)
+                    {
+                        Element('em_input_writeExpressoCalendar').disabled = true;
+                        Element('em_input_deleteExpressoCalendar').disabled = true;
+                        Element('em_input_readExpressoCalendar').disabled = true;
+                        Element('em_input_writeExpressoCalendar').checked = false;
+                        Element('em_input_deleteExpressoCalendar').checked = false;
+                        Element('em_input_readExpressoCalendar').checked = false;
+                                              
+                        
+                        acl += 'b'
+                    }
+                    else
+                    {
+                        Element('em_input_readExpressoCalendar').disabled = false;
+                        if (Element('em_input_readExpressoCalendar').checked)
+                        {
+                            acl += 'r';
+
+                            Element('em_input_writeExpressoCalendar').disabled = false;
+                            Element('em_input_deleteExpressoCalendar').disabled = false;
+                            //Element('em_input_freebusyExpressoCalendar').disabled = false;
+
+                            if (Element('em_input_writeExpressoCalendar').checked)
+                                    acl += 'w';
+
+                            if (Element('em_input_deleteExpressoCalendar').checked)
+                                    acl += 'd';
+
+                        }
+                        else
+                        {
+                            Element('em_input_writeExpressoCalendar').disabled = true;
+                            Element('em_input_deleteExpressoCalendar').disabled = true;
+                            //Element('em_input_freebusyExpressoCalendar').disabled = true;
+                            Element('em_input_writeExpressoCalendar').checked = false;
+                            Element('em_input_deleteExpressoCalendar').checked = false;
+                           // Element('em_input_freebusyExpressoCalendar').checked = false;
+                        }
+
+                    }
+                    
+                    this.ownersExpressoCalendarAcl[user] = acl;
                 }
 	}
@@ -650,4 +890,5 @@
 		Element('em_input_saveAcl').checked = false;
 		Element('em_input_folderAcl').checked = false;
+                
                 Element('em_input_readCalendar').checked = false;
                 Element('em_input_writeCalendar').checked = false;
@@ -655,4 +896,9 @@
                 Element('em_input_deleteCalendar').checked = false;
                 Element('em_input_restrictCalendar').checked = false;
+                
+                Element('em_input_readExpressoCalendar').disabled = true;
+                Element('em_input_writeExpressoCalendar').disabled = true;
+                Element('em_input_deleteExpressoCalendar').disabled = true;
+                Element('em_input_readExpressoCalendar').disabled = true;
 	}
 	
